#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

/*
parameters should be --allow-root=/project-dir
environment variables are:
 BASE - the chroot jail
 GID - the group ID of the cvs user
 UID - the user ID of the cvs user
*/

#define MAX_ARGS 29

int main(int argc, char *argv[])
{
	int i;
	char *p;
	char *newargv[MAX_ARGS+1];

	if (argc<2) {
		puts("Usage: run-cvs --allow-root=/REPOSITORY\n");
		exit(6);
	}
	if (p=getenv("BASE"))
	{
		if (chdir(p)) {
			puts("Couldn't chdir.\n"); exit(1);
		}
		if (chroot(p)) {
			puts("Couldn't chroot.\n"); exit(2);
		}
	} else {
		puts("Need BASE env variable.\n"); exit(8);
	}
	if (p=getenv("GID"))
	{
		if (setgid(atoi(p))) {
			puts("Couldn't change group.\n"); exit(3);
		}
	} else {
		puts("Need GID env variable.\n"); exit(9);
	}
	if (p=getenv("UID"))
	{
		if (setuid(atoi(p))) {
			puts("Couldn't change uid.\n"); exit(4);
		}
	} else {
		puts("Need UID env variable.\n"); exit(10);
	}

	newargv[0]="cvs";
        if (argc>MAX_ARGS+1) argc=MAX_ARGS+1;

	for (i=1; i<argc; i++)
	{
		newargv[i]=argv[i];
	}
	newargv[i++]="pserver";
	newargv[i]=NULL;

	execv("/bin/cvs",newargv);
	puts("execv failed.\n");
	exit(errno);
}
